<template>
	<div class="d-inline-flex">
		<v-btn color="green" class="white--text float-right mt-4 mr-2 px-4" @click="showSubmitDialog = true">
			Submit
		</v-btn>

		<confirm-dialog
			v-model="showSubmitDialog"
			title="Submit Sampling Collection"
			:error="
				submitHasError
					? 'An error occurred while attempting to submit the sampling collection. Please try again.'
					: samplings.length === 0
					? 'You cannot submit an empty sampling collection.'
					: null
			"
			:loading="submitIsLoading"
			:message="
				samplings.length > 0
					? 'You will no longer be able to edit this sampling collection once you submit. Your in progress collection is automatically saved to your device. Are you sure you want to submit?'
					: null
			"
			:button="samplings.length > 0 ? 'Confirm' : null"
			button-color="primary"
			persistent
			@confirm="handleSubmit"
			@cleanup="handleCleanup"
		>
			<template slot="content-header">
				<v-card-text class="py-4">
					<span class="font-weight-bold">Field</span>: {{ field.name }}
					<br />
					<v-icon small class="mr-1"> mdi-triangle </v-icon>
					{{ progress }} locations collected
				</v-card-text>
			</template>
		</confirm-dialog>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import { Feature, FeatureCollection } from 'geojson';
import ConfirmDialog from '@/components/dialog/ConfirmDialog.vue';
import { Field, Sample, Sampling, SamplingCollection } from '@/store/types';
import { prepareSamplingCollectionForSubmission } from './helpers';

export default defineComponent({
	components: { ConfirmDialog },
	props: {
		locations: {
			type: Object as () => FeatureCollection,
			required: true,
		},
		field: {
			type: Object as () => Field,
			required: true,
		},
		samplingCollection: {
			type: Object as () => SamplingCollection,
			required: true,
		},
		samplings: {
			type: Array as () => Sampling[],
			required: true,
		},
		samples: {
			type: Array as () => Sample[],
			required: true,
		},
	},
	setup(props, { root }) {
		const showSubmitDialog = ref<boolean>(false);
		const progress = computed(() => {
			if (props.locations) {
				const completed = props.locations.features.filter(
					(l: Feature) => l.properties?.markerType !== 'LOCATION_INCOMPLETE'
				).length;
				const total = props.locations.features.length;
				return `${completed} / ${total}`;
			}
		});

		const submitIsLoading = computed(() => root.$store.getters['resources/getSubmitIsLoading']);
		const submitHasError = computed(() => root.$store.getters['resources/getSubmitHasError']);

		const handleSubmit = () => {
			const submittableSamplingCollection = prepareSamplingCollectionForSubmission({
				samplingCollection: props.samplingCollection,
				samplings: props.samplings,
				samples: props.samples,
			});

			root.$store.dispatch('resources/submitSamplingCollection', {
				populatedSamplingCollection: submittableSamplingCollection,
				locationCollectionId: props.samplingCollection.object,
			});
		};

		const handleCleanup = () => root.$store.dispatch('resources/acknowledgeSubmitSamplingCollectionError');

		return {
			showSubmitDialog,
			progress,
			submitIsLoading,
			submitHasError,
			handleSubmit,
			handleCleanup,
		};
	},
});
</script>

<style></style>
